package com.sms.alain.myserversms;
/*
http://10.0.95.249:8765
{"SMS": {
         "number": "06XXXXXXXX",
        "text": "mon message SMS"
        }}
 */

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.widget.ArrayAdapter;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;


public class MainActivity extends Activity {
    final static String INTENT_NAME = "com.sms.alain.broadcast.intent.Message";
    private TextView edPort;
    private TextView textIpaddr;
    ArrayList<String> smsMessagesList = new ArrayList<String>();
    ListView smsListView;
    ArrayAdapter arrayAdapter;

    /**
     * Lorsque l'appli est cree, on connecte les objets aux widgets de l'UI
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        ToggleButton onOffBouton;
        int port;
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        textIpaddr = (TextView) findViewById(R.id.ipaddr);
        edPort = (EditText) findViewById(R.id.port);
        onOffBouton = (ToggleButton) findViewById(R.id.onOffButton);
        smsListView = (ListView) findViewById(R.id.lstView);
        arrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, smsMessagesList);
        smsListView.setAdapter(arrayAdapter);

        WifiManager wifiManager = (WifiManager) getApplicationContext().getSystemService(WIFI_SERVICE);
        if (!wifiManager.isWifiEnabled()) {
            Toast.makeText(this, "WiFi désactivé", Toast.LENGTH_LONG).show();
        }
        if (wifiManager.getConnectionInfo().getIpAddress()==0) {
            Toast.makeText(this, "pas d'adresse IP", Toast.LENGTH_LONG).show();
        }
        int ipAddress = wifiManager.getConnectionInfo().getIpAddress();
        final String formatedIpAddress = String.format("%d.%d.%d.%d", (ipAddress & 0xff), (ipAddress >> 8 & 0xff),
                (ipAddress >> 16 & 0xff), (ipAddress >> 24 & 0xff));

        port = Integer.parseInt(edPort.getText().toString());
        textIpaddr.setText("Accès : http://" + formatedIpAddress + ":" + port);


        onOffBouton.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                Intent intent = new Intent(MainActivity.this, ServeurSMSService.class);
                intent.putExtra("IP", textIpaddr.getText().toString());
                intent.putExtra("PORT", edPort.getText().toString());
                if (isChecked) {
                    startService(intent);
                } else {
                    stopService(new Intent(MainActivity.this, ServeurSMSService.class));
                }
            }
        });
        registerReceiver(broadcastReceiver, new IntentFilter(INTENT_NAME));
    }

    @Override
    public void onResume() {
        super.onResume();

    }

    @Override
    public void onPause() {
        super.onPause();
     //   unregisterReceiver(broadcastReceiver);
    }

    private BroadcastReceiver broadcastReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String numero = intent.getStringExtra("number");
            String text = intent.getStringExtra("text");
            DateFormat df = new SimpleDateFormat("d MMM yyyy HH:mm:ss");
            String message = df.format(Calendar.getInstance().getTime()).toString();

            message = message + " => " + numero + "\n" + text + "\n";
            arrayAdapter.insert(message,0);
            arrayAdapter.notifyDataSetChanged();
        }
    };
}

